CREATE TABLE  `dynamite`.`board_table` (
  `board_id` varchar(45) NOT NULL,
  `board_name` varchar(45) NOT NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`board_id`)
);

CREATE TABLE  `dynamite`.`privilege_table` (
  `privilege_id` varchar(45) NOT NULL,
  `privilege_name` varchar(45) NOT NULL,
  `reource_category_id` varchar(45) NOT NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`privilege_id`),
  KEY `FK_privilege_table_resource_category` (`reource_category_id`),
  CONSTRAINT `FK_privilege_table_resource_category` FOREIGN KEY (`reource_category_id`) REFERENCES `resource_category` (`category_id`)
);

CREATE TABLE  `dynamite`.`resource_category` (
  `category_id` varchar(45) NOT NULL,
  `category_name` varchar(45) NOT NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`category_id`)
);

CREATE TABLE  `dynamite`.`resource_table` (
  `resource_id` varchar(45) NOT NULL,
  `resource_name` varchar(45) NOT NULL,
  `resource_category_id` varchar(45) NOT NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`resource_id`),
  KEY `FK_resource_table_resource_category` (`resource_category_id`),
  CONSTRAINT `FK_resource_table_resource_category` FOREIGN KEY (`resource_category_id`) REFERENCES `resource_category` (`category_id`)
);

CREATE TABLE  `dynamite`.`role_table` (
  `role_id` varchar(45) NOT NULL,
  `role_name` varchar(45) NOT NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`role_id`)
);

CREATE TABLE  `dynamite`.`user_resource_privilege_map_table` (
  `map_id` int(10) unsigned NOT NULL auto_increment,
  `user_id` varchar(45) NOT NULL,
  `resource_id` varchar(45) NOT NULL,
  `privilege_id` varchar(45) NOT NULL,
  PRIMARY KEY  (`map_id`),
  KEY `FK_user_resource_privilege_map_table_user_id` (`user_id`),
  KEY `FK_user_resource_privilege_map_table_resource_id` (`resource_id`),
  KEY `FK_user_resource_privilege_map_table_privilege_id` (`privilege_id`),
  CONSTRAINT `FK_user_resource_privilege_map_table_privilege_id` FOREIGN KEY (`privilege_id`) REFERENCES `privilege_table` (`privilege_id`),
  CONSTRAINT `FK_user_resource_privilege_map_table_resource_id` FOREIGN KEY (`resource_id`) REFERENCES `resource_table` (`resource_id`),
  CONSTRAINT `FK_user_resource_privilege_map_table_user_id` FOREIGN KEY (`user_id`) REFERENCES `user_table` (`user_id`)
);

CREATE TABLE  `dynamite`.`user_role_map_table` (
  `user_id` varchar(45) NOT NULL default '',
  `role_id` varchar(45) default NULL,
  PRIMARY KEY  (`user_id`),
  KEY `FK_user_role_map_table_role_id` (`role_id`),
  CONSTRAINT `FK_user_role_map_table_role_id` FOREIGN KEY (`role_id`) REFERENCES `role_table` (`role_id`),
  CONSTRAINT `FK_user_role_map_table_user_id` FOREIGN KEY (`user_id`) REFERENCES `user_table` (`user_id`)
);

CREATE TABLE  `dynamite`.`user_table` (
  `user_id` varchar(45) NOT NULL,
  `user_name` varchar(45) NOT NULL,
  `user_password` varchar(45) NOT NULL,
  PRIMARY KEY  (`user_id`)
);

